
package com.aukcjomat;
import com.aukcjomat.parser.*;
import org.htmlparser.*;
import org.htmlparser.util.*;
import java.util.*;

public class FajnyParser
{
    boolean filtr_kat(String url)
    {
        if (url.indexOf("12")>=0 || url.indexOf(":all")>=0 || url.indexOf("jsessionid")>=0)
          return true;
        System.out.println("UWAGA! na poczatku pliku FajnyParser funkcja filtr_kat odrucila ta kategorie, url="+url);
        return false;
    }

    static final int U_skok = 100;
    static final int U_try = 5;

    static final int C_LISTA_KATEGORII = 0;
    static final int C_LISTA_KATEGORII2 = 1;
    static final int C_LISTA_AUKCJI = 2;
    static final int C_AUKCJA = 3;
    static final int C_USER = 4;
    static final int C_USER_GLOWNY = 5;

    static class Rodzaj
    {
        public int typ;
        public String url;
        public Mapa mapa;
        public int nr;
        Rodzaj(int typ, String url, Mapa mapa)
        { 
            this.mapa = mapa;
            this.url = url; 
            this.typ = typ; 
            System.out.println("Skolejkowano: "+url);
        }
        Rodzaj(int typ, String url, Mapa mapa, int nr)
        { 
            this.mapa = mapa;
            this.url = url; 
            this.typ = typ; 
            this.nr = nr;
            System.out.println("Skolejkowano: "+url+nr);
        }
    }

    public SietsAPI siets = new SietsAPI();
    //public com.aukcjomat.parser.SietsAPI siets = new com.aukcjomat.parser.SietsAPI();
    MadryParser parser_kom = new MadryParser(this);
    public Mapa mapa;
    Cos main_cos;
    Parser parser;
    public HashMap ret_of;
    
    Rozpoznawacz rozpoznawacz = new Rozpoznawacz();

////

    String popraw_kreske(String s)
    {
        return s.equals("-") ? "0" : s;
    }

    public String absoluteUrl(String url)
    {
        if (url.equals(""))
            return "";
        return parser.getLexer().getPage().getAbsoluteURL(url);
    }


    LinkedList znajdz_wiele(String str, Cos start, Cos stop)
    {
        return rozpoznawacz.dzialaj(mapa.get("p_"+str), start, stop, str);
    }

    LinkedList znajdz_wiele(String str)
    {
        return znajdz_wiele(str, main_cos, main_cos.pair);
    }

    Para znajdz_jeden(String str)
    {
        LinkedList l = znajdz_wiele(str);
        return l.size()==0 ? null : (Para)l.getFirst();
    }

    Para znajdz_jeden(String str, Cos start, Cos stop)
    {
        LinkedList l = 
            rozpoznawacz.dzialaj(mapa.get("p_"+str), start, stop, str);
        return l.size()==0 ? null : (Para)l.getFirst();
    }

//////

    void parsuj_liste_kategorii(boolean glowne) throws ParserException
    {
        LinkedList linie = znajdz_wiele(glowne ? "glkat" : "kat");
        while(linie.size()>0)
        {
            Para p = (Para)linie.removeFirst();
            String url = absoluteUrl(rozpoznawacz.rozpoznaj_linka(p.x, p.y));
            if (filtr_kat(url))
                 Sciagacz.sciagaj(new Rodzaj(glowne ? C_LISTA_KATEGORII2 : C_LISTA_AUKCJI, 
                     url, mapa));
        }
    }
////////////

    void parsuj_liste_ofert() throws ParserException
    {
        Para p = znajdz_jeden("nastepna");
        if (p!=null)
            Sciagacz.sciagaj(new Rodzaj(C_LISTA_AUKCJI, 
                absoluteUrl(rozpoznawacz.rozpoznaj_linka(p.x, p.y)), mapa));

        boolean najpierw_kup_teraz = mapa.get("kolejnosc").equals("1");
        boolean bez_kup_teraz = mapa.get("kolejnosc").equals("2");
        rozpoznawacz.naprawiaj_cene = true;

        LinkedList kat0 = znajdz_wiele("lo_kategoria");
        String glowna_kat = "";
        while (kat0.size()>0)
        {
            Para p_k = (Para)kat0.removeFirst();
            if (!glowna_kat.equals(""))
                glowna_kat += " > ";
            glowna_kat += rozpoznawacz.rozpoznaj_tresc(p_k.x, p_k.y);
        }
        kat0 = znajdz_wiele("lo_kategoria2");
        Object[] tablica = kat0.toArray();
        for (int a = 0; a<tablica.length; ++a)
            ((Para)tablica[a]).dodatek = 1;
        
        LinkedList linie = znajdz_wiele("wiersz");
        linie.addAll(kat0);
        Collections.sort(linie);

        boolean byla_kat = false;
        String nazwa_kat = glowna_kat;
        
        while(linie.size()>0)
        {
            ret_of = new HashMap();
            Para p1 = (Para)linie.removeFirst();
            
            if (p1.dodatek==1)
            {
                if (!byla_kat)
                    nazwa_kat = glowna_kat;
                glowna_kat += " > "+rozpoznawacz.rozpoznaj_tresc(p1.x, p1.y);
                byla_kat = true;
                continue;
            }

            if (!nazwa_kat.equals(""))
                ret_of.put("kategoria", glowna_kat);
            
            byla_kat = false;            
            p = znajdz_jeden("nazwa", p1.x, p1.y);
            if (p!=null)
            {
                ret_of.put("url", absoluteUrl(rozpoznawacz.rozpoznaj_linka(p.x, p.y)));
                ret_of.put("nazwa", rozpoznawacz.rozpoznaj_tresc(p.x, p.y));
            }
            boolean kup_teraz = (znajdz_jeden("kup_teraz", p1.x, p1.y)!=null);
            p = znajdz_jeden("ile_ofert", p1.x, p1.y);
            if (p!=null)
                ret_of.put("ile_ofert", popraw_kreske(rozpoznawacz.rozpoznaj_tresc(p.x, p.y)));
            p = znajdz_jeden("lo_opis", p1.x, p1.y);
            if (p!=null)
                ret_of.put("opis", rozpoznawacz.rozpoznaj_tresc(p.x, p.y));
            p = znajdz_jeden("lo_obrazki", p1.x, p1.y);
            if (p!=null)
            {
                LinkedList obr = Okreslacz.znajdz_img_alt(p.x, p.y);
                String obr_s = "";
                while (obr.size()>0)
                    obr_s = (obr_s+" "+((String)obr.removeFirst())).trim();
                if (!obr_s.equals(""))
                    ret_of.put("obrazki", obr_s);
            }
            p = znajdz_jeden("cena", p1.x, p1.y);
            if (p==null) continue;
            rozpoznawacz.rozpoznaj_ceny_na_liscie(p.x, p.y, kup_teraz, najpierw_kup_teraz);
            ret_of.put("cena", rozpoznawacz.cena_zw);
            if (!bez_kup_teraz)
                ret_of.put("cena_kup_teraz", rozpoznawacz.cena_kt);
            //if (ret_of.size()!=5)
            //    continue;
            String url = (String)ret_of.get("url");
            ret_of.put("serwis", mapa.nazwa);
            if (mapa.get("lo_wchodz").equals("1") && !siets.doLookup(url))
                Sciagacz.sciagaj(new Rodzaj(C_AUKCJA, url, mapa));
            siets.doUpdate(url, ret_of);
        }
    }
////////

    void parsuj_atrybuty(String dod, Para p) throws ParserException
    {
        LinkedList linie = znajdz_wiele("a_atrybut"+dod);
        while(linie.size()>0)
        {
            Para p1 = (Para)linie.removeFirst();
            Para p_n = znajdz_jeden("a_atr_nazwa"+dod, p1.x, p1.y);
            Para p_w = znajdz_jeden("a_atr_war"+dod, p1.x, p1.y);
            if (p_n!=null && p_w!=null)
                ret_of.put(rozpoznawacz.rozpoznaj_tresc(p_n.x, p_n.y), 
                    rozpoznawacz.rozpoznaj_tresc(p_w.x, p_w.y));
            if (p!=null && p1.y.nr>p.x.nr)
                p.x = p1.y;
        }
    }

    void parsuj_oferte_dzialaj(String url) throws ParserException
    {
        ret_of = new HashMap();
        ret_of.put("url", url);
        String nazwa_kat = "";
        Para p_n = znajdz_jeden("a_nazwa_kat_cale");
        if (p_n!=null)
        {
            LinkedList linie = znajdz_wiele("a_nazwa_kat", p_n.x, p_n.y);
            while(linie.size()>0)
            {
                Para p1 = (Para)linie.removeFirst();
                if (!nazwa_kat.equals(""))
                    nazwa_kat += " > ";
                nazwa_kat += rozpoznawacz.rozpoznaj_tresc(p1.x, p1.y);
                ret_of.put("kategoria", nazwa_kat);
            }
        }
        Para p = znajdz_jeden("a_sprzedawca");
        if (p!=null)
        {
            ret_of.put("sprzedawca", rozpoznawacz.rozpoznaj_tresc(p.x, p.y));
            int uid = parser_kom.url2uid(rozpoznawacz.rozpoznaj_linka(p.x, p.y));
            if (uid>=0)
              ret_of.put("uid_sprzedawcy", ""+uid);
        }
        LinkedList dodatkowe = Tools.rozwal_dodatkowe(mapa.get("a_dodatkowe"));
        while (dodatkowe.size()>0)
        {
            String nazwa = (String)dodatkowe.removeFirst();
            p = znajdz_jeden("a_x_"+nazwa);
            if (p!=null)
                ret_of.put(nazwa, rozpoznawacz.rozpoznaj_tresc(p.x, p.y));
        }
        rozpoznawacz.naprawiaj_cene = true;
        p = znajdz_jeden("a_cena");
        if (p!=null)
        {
            String cena = rozpoznawacz.rozpoznaj_cene(p.x, p.y);
            ret_of.put("cena", cena);
        }
        p = znajdz_jeden("a_cena_kup_teraz");
        if (p!=null)
        {
            String cena = rozpoznawacz.rozpoznaj_cene(p.x, p.y);
            ret_of.put("cena_kup_teraz", cena);
        }
        p = znajdz_jeden("a_czas_konca");
        if (p!=null)
        {
            long data = rozpoznawacz.rozpoznaj_date(p.x, p.y, mapa.get("a_data_for"), 
                mapa.get("a_jezyk"));
            if (data>=0)
                ret_of.put("czas_konca", ""+data);
        }
        p = znajdz_jeden("a_opis");
        parsuj_atrybuty("", p);
        parsuj_atrybuty("2", p);
        if (p!=null)
        {
            while (!p.x.first && p.x.nr<=p.y.nr) p.x = p.x.next;
            ret_of.put("opis", rozpoznawacz.rozpoznaj_tresc(p.x, p.y));
        }
    }

    void parsuj_oferte(String url) throws ParserException
    {
        parsuj_oferte_dzialaj(url);
        ret_of.put("serwis", mapa.nazwa);
        siets.doUpdate(url, ret_of);
    }



    void sciagaj_url(String url, boolean przygotuj) throws ParserException
    {
        System.out.println("Bede sciagal: "+url);
        parser = new Parser(url); 
        //parser_kom.wyswietl_strone(parser.elements());
        System.out.println("OK");
        if (przygotuj)
        {
            main_cos = Cos.przygotuj(parser.elements());
            System.out.println("Rozmiar strony: "+main_cos.pair.nr);
            if (main_cos.pair.nr<40)
            {
              sciagaj_url(url, false);
              main_cos = Cos.przygotuj(parser.elements());
              System.out.println("Rozmiar strony: "+main_cos.pair.nr);
            }
        }
    }
    
    boolean probuj_usera(String url)
    {
        try
        {
            while (!url.equals(""))
            {
                sciagaj_url(url, false);
                url = absoluteUrl(parser_kom.parsuj_usera(parser.elements(), url));
                System.out.println("OK2");
            }
            return true;
        }
        catch (ParserException e)
        {
            System.out.println("Blad: " + e.toString());
            e.printStackTrace();
            return false;
        }
    }

    public boolean sciagaj_aukcje_dla_kom(String url)
    {
        try
        {
            sciagaj_url(url, true);
            parsuj_oferte_dzialaj(url);
            System.out.println("OK2");
            return true;
        }
        catch (ParserException e)
        {
            System.out.println("Blad: " + e.toString());
            e.printStackTrace();
            return false;
        }
    }
    
    public void naprawde_parsuj(Object cos)
    {
        try
        {
            Rodzaj r = (Rodzaj)cos;
            if (r.url.equals(""))
                return;
            mapa = r.mapa;
            
            if (r.typ==C_USER_GLOWNY)
            {
                boolean ok = false;
                for (int a = r.nr; a<r.nr+U_try; ++a)
                    ok = probuj_usera(r.url+a)|ok;
                if (ok)
                {
                    Sciagacz.sciagaj(new Rodzaj(C_USER_GLOWNY, r.url, mapa, r.nr+U_skok));
                    for (int a = r.nr+U_try; a<r.nr+U_skok; ++a)
                        Sciagacz.sciagaj(new Rodzaj(C_USER, r.url, mapa, a));
                }
                return;
            }
            if (r.typ==C_USER)
            {
                probuj_usera(r.url+r.nr);
                return;
            }
            
            sciagaj_url(r.url, true);
            if (r.typ==C_LISTA_KATEGORII || r.typ==C_LISTA_KATEGORII2)
                parsuj_liste_kategorii(mapa.get("lk_dwupoziomowe").equals("1") && 
                  r.typ==C_LISTA_KATEGORII);
            else
            if (r.typ==C_LISTA_AUKCJI)
                parsuj_liste_ofert();
            else
            if (r.typ==C_AUKCJA)
                parsuj_oferte(r.url);
            System.out.println("OK2");
        }
        catch (ParserException e)
        {
            System.out.println("Blad: " + e.toString());
            e.printStackTrace();
        }
    }


    static public boolean parsuj_kom(String schemat, int poczatek)
    {
        Mapa mapa = new Mapa(schemat, (new ApiBazySch()).wezSchemat(schemat));
        if (mapa.get("kom_url").equals(""))
          return false;
        Sciagacz.sciagaj(new Rodzaj(C_USER_GLOWNY, mapa.get("kom_url"), mapa, poczatek));
        return true;
    }

    static public boolean parsuj(String schemat)
    {
        Mapa mapa = new Mapa(schemat, (new ApiBazySch()).wezSchemat(schemat));
        if (mapa.get("main_url").equals(""))
          return false;
        Sciagacz.sciagaj(new Rodzaj(C_LISTA_KATEGORII, mapa.get("main_url"), mapa));
        return true;
    }
};
