/*
 * Konf.java
 *
 */

package com.aukcjomat;

import com.aukcjomat.parser.*;

import java.io.*;
import java.text.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import org.htmlparser.*;
import org.htmlparser.util.*;
import org.htmlparser.lexer.*;

/**
 * Konfigurowalny parser do stron aukcji internetowych.
 *
 * @author Pawel Parys
 */

public class Konf extends HttpServlet {

////////////////////////

    Mapa mapa;
    
    NodeIterator nodes;
    //String strona;
    Parser parser;

    Okreslacz okreslacz = new Okreslacz();


    void przygotuj() throws ParserException
    {
        okreslacz.main_cos = main_cos = Cos.przygotuj(nodes);
    }

    
    Cos main_cos;

////////////////////////////////////////////
    
/*    LinkedList lista_przodkow(Cos n)
    {
        LinkedList l = new LinkedList();
        for (; n!=null; n = n.up)
            l.addFirst(n);
        return l;
    }*/
    
    


    boolean changed(String n)
    {
        return !mapa.get(n).equals(mapa.get(n+"_"));
    }

    boolean probuj_okreslic_wiersz()    throws ParserException
    {
        boolean zm0 = changed("nazwa_aukcji0") || changed("nazwa_aukcji1");
        boolean zm1 = changed("nazwa_aukcji2") || changed("nazwa_aukcji3");
        if (!zm0 && !zm1)
            return false;
            
        String s;// = mapa.get("p_wiersz");
        String sch0, sch1;
/*        int x = znajdz_kreske(s, 0);
        int x2 = x<s.length() ? x+1 : s.length();
        int y = znajdz_kreske(s, x2);
        if (y<s.length())
            zm0 = zm1 = true;         // nie daje sie poprawic, gdy: jest duzo kresek
        if (zm0)*/
            sch0 = okreslacz.lista_wiersz(mapa.get("nazwa_aukcji0"), mapa.get("nazwa_aukcji1"));
//        else
//            sch0 = s.substring(0, x);
//        if (zm1)
            sch1 = okreslacz.lista_wiersz(mapa.get("nazwa_aukcji2"), mapa.get("nazwa_aukcji3"));
//        else
//            sch1 = s.substring(x2, y);
        if (sch0.equals(""))
            s = sch1;
        else
        if (sch1.equals(""))
            s = sch0;
        else
            s = sch0+"|"+sch1; 
        mapa.update("p_wiersz", s);
        return true;
    }
    
    
    void probuj_okreslic_liste()    throws ParserException
    {
        boolean zm = probuj_okreslic_wiersz();
        if (changed("nastepna"))
            mapa.update("p_nastepna", okreslacz.lista_nastepna(mapa.get("nastepna")));
        if (changed("lo_kategoria"))
            mapa.update("p_lo_kategoria", okreslacz.lista_kategoria(mapa.get("lo_kategoria")));
        if (changed("lo_kategoria2"))
            mapa.update("p_lo_kategoria2", okreslacz.lista_kategoria(mapa.get("lo_kategoria2")));
        LinkedList linie = znajdz_wiele("wiersz");
        boolean czy_obrazki = mapa.get("lo_czy_obrazki").equals("1");
        if (!czy_obrazki)
            mapa.mapa.put("p_lo_obrazki", "");
        while(linie.size()>0)
        {
            Para p = (Para)linie.removeFirst();
            if (changed("nazwa_aukcji0"))
                mapa.update("p_nazwa", okreslacz.lista_nazwa(mapa.get("nazwa_aukcji0"), p.x, p.y));
            if (changed("kup_teraz") || changed("kup_teraz_txt") || changed("kup_teraz_img"))
                mapa.update("p_kup_teraz", okreslacz.lista_kup_teraz(mapa.get("kup_teraz"), 
                    mapa.get("kup_teraz_txt"), mapa.get("kup_teraz_img"), p.x, p.y));
            if (changed("cena"))
                mapa.update("p_cena", okreslacz.lista_cena(mapa.get("cena"), p.x, p.y));
            if (changed("ile_ofert"))
                mapa.update("p_ile_ofert", okreslacz.lista_ile_ofert(mapa.get("ile_ofert"), p.x, p.y));
            if (changed("lo_opis"))
                mapa.update("p_lo_opis", okreslacz.lista_opis(mapa.get("lo_opis"), p.x, p.y));
            if (czy_obrazki && (changed("lo_czy_obrazki") || changed("lo_obrazki_alt")))
                mapa.update("p_lo_obrazki", okreslacz.lista_obrazki(
                    mapa.get("lo_obrazki_alt"), p.x, p.y));
        }
    }

/////////////////////////

    
    void probuj_okr_lk_dzialaj(String n_wst, String n_wyn) throws ParserException
    {
        if (changed(n_wst+"0") || changed(n_wst+"1"))
            mapa.update(n_wyn, 
                okreslacz.lk_kategoria(mapa.get(n_wst+"0"), mapa.get(n_wst+"1")));
    }
    
    void probuj_okreslic_lk()    throws ParserException
    {
        probuj_okr_lk_dzialaj("nazwa_kat", "p_kat");
        probuj_okr_lk_dzialaj("nazwa_glkat", "p_glkat");
    }

/////////////////////////////////////

    boolean probuj_okreslic_atrybuty(String dod)
    {
        if (!changed("a_atr0"+dod) && !changed("a_atr1"+dod))
            return false;
        mapa.update("p_a_atrybut"+dod, okreslacz.atrybut(mapa.get("a_atr0"+dod), mapa.get("a_atr1"+dod)));
        return true;
    }

    void okreslanie_dla_atrybutow(String dod)
    {
        boolean zm = probuj_okreslic_atrybuty(dod);
        LinkedList linie = znajdz_wiele("a_atrybut"+dod);
        while(linie.size()>0)
        {
            Para p = (Para)linie.removeFirst();
            if (zm || changed("a_atr0"+dod))
                mapa.update("p_a_atr_nazwa"+dod, okreslacz.atr_nazwa(mapa.get("a_atr0"+dod), p.x, p.y));
            if (zm || changed("a_atrv"+dod))
                mapa.update("p_a_atr_war"+dod, okreslacz.atr_wartosc(mapa.get("a_atrv"+dod), p.x, p.y));
        }
    }

    void probuj_okr_zwykle(String n, boolean z_linkiem)
    {
        if (changed("a_"+n) || changed("wa_"+n))
            mapa.update("p_a_"+n, okreslacz.a_zwykle(mapa.get("a_"+n), mapa.get("wa_"+n), z_linkiem));
    }

    void probuj_okr_zwykle(String n)
    {
      probuj_okr_zwykle(n, false);
    }

    void probuj_okreslic_aukcje()    throws ParserException
    {
        if (changed("a_nazwa_kat0") || changed("a_nazwa_kat1"))
        {
            mapa.update("p_a_nazwa_kat_cale", 
                okreslacz.a_kategoria(mapa.get("a_nazwa_kat0"), mapa.get("a_nazwa_kat1")));
            Para p = znajdz_jeden("a_nazwa_kat_cale");
            if (p!=null)
                mapa.update("p_a_nazwa_kat", okreslacz.a_kategoria_wew(mapa.get("a_nazwa_kat0"), 
                    mapa.get("a_nazwa_kat1"), p.x, p.y));
        }
        probuj_okr_zwykle("cena");
        probuj_okr_zwykle("cena_kup_teraz");
        probuj_okr_zwykle("sprzedawca", true);
        probuj_okr_zwykle("czas_konca");
        LinkedList dodatkowe = Tools.rozwal_dodatkowe(mapa.get("a_dodatkowe"));
        while (dodatkowe.size()>0)
        {
            String p = (String)dodatkowe.removeFirst();
            probuj_okr_zwykle("x_"+p);
        }
        if (changed("a_opis") || changed("a_koniec") || changed("a_koniec_txt") || 
                changed("a_koniec_remark") || changed("a_opis_nr"))
            mapa.update("p_a_opis", okreslacz.a_opis(mapa.get("a_opis_nr"), mapa.get("a_opis"), 
                mapa.get("a_koniec"), mapa.get("a_koniec_txt"), mapa.get("a_koniec_remark")));
        okreslanie_dla_atrybutow("");
        okreslanie_dla_atrybutow("2");
    }


///////////////////////////////////////////////////////
///////////////////////////////////////////////////////
    
    Rozpoznawacz rozpoznawacz = new Rozpoznawacz();

    LinkedList znajdz_wiele(String str, Cos start, Cos stop)
    {
        return rozpoznawacz.dzialaj(mapa.get("p_"+str), start, stop, str);
    }

    LinkedList znajdz_wiele(String str)
    {
        return znajdz_wiele(str, main_cos, main_cos.pair);
    }

    Para znajdz_jeden(String str)
    {
        LinkedList l = znajdz_wiele(str);
        return l.size()==0 ? null : (Para)l.getFirst();
    }

    Para znajdz_jeden(String str, Cos start, Cos stop)
    {
        LinkedList l = 
            rozpoznawacz.dzialaj(mapa.get("p_"+str), start, stop, str);
        return l.size()==0 ? null : (Para)l.getFirst();
    }

    boolean zaznacz(String n, String txt, Cos start, Cos stop) throws ParserException
    {
        Para p = znajdz_jeden(n, start, stop);
        if (p==null)
            return false;
        gen_html.zamieniaj(txt, p.x, p.y);
        return true;
    }

    boolean zaznacz(String n, String txt) throws ParserException
    {
        return zaznacz(n, txt, main_cos, main_cos.pair);
    }
////////////

    void zaznacz_kat(String n, String txt) throws ParserException
    {
        LinkedList l = znajdz_wiele(n);
        while (l.size()>0)
        {
          Para p = (Para)l.removeFirst();
          gen_html.zamieniaj(txt, p.x, p.y);
        }
    }

    void probuj_parsowac_liste() throws ParserException
    {
        zaznacz("nastepna", "NASTEPNA");
        zaznacz_kat("lo_kategoria", "KATEGORIA (CAO)");
        zaznacz_kat("lo_kategoria2", "KATEGORIA (CZʦ)");

        boolean najpierw_kup_teraz = mapa.get("kolejnosc").equals("1");
        boolean bez_kup_teraz = mapa.get("kolejnosc").equals("2");
        rozpoznawacz.naprawiaj_cene = false;

        LinkedList linie = znajdz_wiele("wiersz");
        while(linie.size()>0)
        {
            Para p1 = (Para)linie.removeFirst();
            zaznacz("nazwa", "NAZWA", p1.x, p1.y);
            boolean kup_teraz = zaznacz("kup_teraz", "KUP_TERAZ", p1.x, p1.y);
            zaznacz("ile_ofert", "ILE OFERT", p1.x, p1.y);
            zaznacz("lo_opis", "OPIS", p1.x, p1.y);
            zaznacz("lo_obrazki", "OBRAZKI", p1.x, p1.y);
            Para p = znajdz_jeden("cena", p1.x, p1.y);
            if (p==null) continue;
            gen_html.zamieniaj("CENY", p.x, p.y);
            rozpoznawacz.rozpoznaj_ceny_na_liscie(p.x, p.y, kup_teraz, najpierw_kup_teraz);
            gen_html.zamieniaj_str("CENA ZWYKLA", rozpoznawacz.cena_zw, p.x, p.y);
            if (!bez_kup_teraz)
                gen_html.zamieniaj_str("CENA KUP TERAZ", rozpoznawacz.cena_kt, p.x, p.y);
        }
    }
//////

    void probuj_parsowac_lk() throws ParserException
    {
        LinkedList linie = znajdz_wiele("kat");
        while(linie.size()>0)
        {
            Para p = (Para)linie.removeFirst();
            if (p!=null) gen_html.zamieniaj("KATEGORIA", p.x, p.y);
        }
        linie = znajdz_wiele("glkat");
        while(linie.size()>0)
        {
            Para p = (Para)linie.removeFirst();
            if (p!=null) gen_html.zamieniaj("GLOWNA KATEGORIA", p.x, p.y);
        }
    }
////////

    void parsuj_atrybuty(String dod, Para p) throws ParserException
    {
        LinkedList linie = znajdz_wiele("a_atrybut"+dod);
        while(linie.size()>0)
        {
            Para p1 = (Para)linie.removeFirst();
            zaznacz("a_atr_nazwa"+dod, "NAZWA ATRYBUTU", p1.x, p1.y);
            zaznacz("a_atr_war"+dod, "WARTOSC ATRYBUTU", p1.x, p1.y);
            if (p!=null && p1.y.nr>p.x.nr) 
                p.x = p1.y;
        }
    }


    void probuj_parsowac_aukcje() throws ParserException
    {
        Para p_n = znajdz_jeden("a_nazwa_kat_cale");
        if (p_n!=null)
        {
            LinkedList linie = znajdz_wiele("a_nazwa_kat", p_n.x, p_n.y);
            while(linie.size()>0)
            {
                Para p1 = (Para)linie.removeFirst();
                gen_html.zamieniaj("KATEGORIA", p1.x, p1.y);
            }
        }
        zaznacz("a_sprzedawca", "SPRZEDAWCA");
        LinkedList dodatkowe = Tools.rozwal_dodatkowe(mapa.get("a_dodatkowe"));
        while (dodatkowe.size()>0)
        {
            String p = (String)dodatkowe.removeFirst();
            zaznacz("a_x_"+p, "POLE("+p+")");
        }
        rozpoznawacz.naprawiaj_cene = false;
        Para p = znajdz_jeden("a_cena");
        if (p!=null)
        {
            String cena = rozpoznawacz.rozpoznaj_cene(p.x, p.y);
            gen_html.zamieniaj_str("CENA ZWYKLA", cena, p.x, p.y);
        }
        p = znajdz_jeden("a_cena_kup_teraz");
        if (p!=null)
        {
            String cena = rozpoznawacz.rozpoznaj_cene(p.x, p.y);
            gen_html.zamieniaj_str("CENA KUP TERAZ", cena, p.x, p.y);
        }
        p = znajdz_jeden("a_czas_konca");
        if (p!=null)
        {
            long data = rozpoznawacz.rozpoznaj_date(p.x, p.y, mapa.get("a_data_for"), 
                mapa.get("a_jezyk"));
            gen_html.zamieniaj("CZAS KONCA"+(data<0 ? " NIEPOPRAWNY FORMAT" : ""), p.x, p.y);
        }
        p = znajdz_jeden("a_opis");
        parsuj_atrybuty("", p);
        parsuj_atrybuty("2", p);
        if (p!=null)
        {
            while (!p.x.first && p.x.nr<=p.y.nr) p.x = p.x.next;
            gen_html.zamieniaj("OPIS", p.x, p.y);
        }
    }

//////////////////////////////////////////////////////////////////


    void pobierzStrone(String url) throws ParserException
    {
        parser = new Parser(url);
        parser = new Parser(url); 
        // dwa razy, zeby poprawnie obsluzyc cookies (np. sklep.komputronik.pl)
        nodes = parser.elements();
    }




    GenHtml gen_html = new GenHtml();
    ApiBazySch baza = new ApiBazySch();

    /**
     * Obsluguje zadania http do tego serwleta, wyswietlajac wszystkie strony potrzebne do skonfigurowania parsera.
     */
    public void service(HttpServletRequest request, HttpServletResponse response)
                throws IOException, ServletException
    {
    try
    {
        request.setCharacterEncoding("UTF-8");
        response.setContentType("text/html");
        response.setCharacterEncoding("UTF-8");
        gen_html.out = response.getWriter();
        String schemat = request.getParameter("schemat");
        if (schemat==null) schemat = "";
        gen_html.mapa = mapa = new Mapa(schemat, baza.wezSchemat(schemat));
        mapa.dorzuc_mape(request.getParameterMap());
        String akcja = mapa.get("akcja");
        
        int A_MAIN = 0;
        int A_SCHEMAT = 1;
        int A_KATEGORIE = 2;   
        int A_LISTA = 3;   
        int A_AUKCJA = 4;
        //int A_SCIAGAJ = 5;
     
        int ak = schemat.equals("") ? A_MAIN :
                akcja.equals("schemat") ? A_SCHEMAT :
                akcja.equals("kategorie") ? A_KATEGORIE :
                akcja.equals("lista") ? A_LISTA :
                akcja.equals("aukcja") ? A_AUKCJA :
                //akcja.equals("sciagaj") ? A_SCIAGAJ :
                A_MAIN;

        //if (ak==A_SCIAGAJ)
        //{
        //    FajnyParser.parsuj(schemat);
        //    return;
        //}

        if (ak==A_MAIN)
        {
            gen_html.main_page(baza.wezNazwy());
            return;
        }

        if (ak==A_SCHEMAT)
        {
            gen_html.edycja_schematu();
            baza.wstawSchemat(schemat, mapa.mapa);
            return;
        }

        try 
        {
	    pobierzStrone(mapa.get("url"));
	    przygotuj();
	    pobierzStrone(mapa.get("url"));
	    przygotuj();	    
            rozpoznawacz.blad_wzoru = "";
	    if (ak==A_LISTA)
	    {
	        probuj_okreslic_liste();
	        probuj_parsowac_liste();
            }
	    if (ak==A_KATEGORIE)
	    {
	        probuj_okreslic_lk();
	        probuj_parsowac_lk();
            }
	    if (ak==A_AUKCJA)
	    {
	        probuj_okreslic_aukcje();
	        probuj_parsowac_aukcje();
            }
            gen_html.wyswietl_strone(main_cos);
	    if (ak==A_LISTA)
                gen_html.stopka_dla_listy(okreslacz.znajdz_img_alt(), rozpoznawacz.blad_wzoru);
            if (ak==A_KATEGORIE)
                gen_html.stopka_dla_lk(rozpoznawacz.blad_wzoru);
            if (ak==A_AUKCJA)
                gen_html.stopka_dla_aukcji(Tools.rozwal_dodatkowe(mapa.get("a_dodatkowe")), 
                    okreslacz.znajdz_remarks(), rozpoznawacz.blad_wzoru);
        } 
	catch (ParserException e)
	{
            gen_html.out.println("Bd parsera: " + e.toString());
	}
    }
    catch (Exception e)
    {
        System.out.println("Bd: " + e.toString());
        e.printStackTrace();
    }
    }


}



