
package com.aukcjomat.parser;

import java.util.*;
import java.io.*;
import org.htmlparser.*;
import org.htmlparser.util.*;
import org.htmlparser.nodes.*;

/**
 * Generator stron w HTMLu.
 *
 * @author Pawel Parys
 */

public class GenHtml
{
    /**
     * Tutaj bedzie zapisywana strona. Musi byc ustawione przed wywolaniem jakiejkolwiek metody.
     */
    public PrintWriter out;
    
    /**
     * Mapa argumentow do formularza. Musi byc ustawiona przed wywolaniem jakiejkolwiek metody.
     */
    public Mapa mapa;
    
    int length = 50;
    
    String esc(String s)
    {
        String s2 = "";
        for (int a = 0; a<s.length(); a++)
            if (s.charAt(a)=='"')
                s2 += "&quot;";
            else
            if (s.charAt(a)=='<')
                s2 += "&lt;";
            else
            if (s.charAt(a)=='>')
                s2 += "&gt;";
            else
            if (s.charAt(a)=='&')
                s2 += "&amp;";
            else
                s2 += s.charAt(a);
        return s2;
    }

    void start_html(String title)
    {
        out.println("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">");
        out.println("<TITLE>"+title+"</TITLE>");
    }

    void stop_html() {}

    void start_form()
    {
        out.println("<form method=\"post\" action=\"Konf\" accept-charset=\"UTF-8\">");
    }
 
    void stop_form() { out.println("</form>"); }

    void start_table(boolean druga)
    { 
        if (druga)
          out.println("<hr><font size=\"-2\">");
        out.println("<table>"); 
    }

    void stop_table(boolean druga)
    {
        out.println("</table>"); 
        if (druga)
          out.println("</font>");
    }
    
    void start_row(String tytul) { out.println("<tr><td>"+tytul+"</td><td>"); }

    void start_row2(String tytul) { out.println("<tr><td>"+tytul+"</td><td colspan=2>"); }

    void stop_row() { out.println("</td></tr>"); }

    void hidden(String n, String v)
    {
        out.println("<input type=\"hidden\" name=\""+esc(n)+"\" value=\""+esc(v)+"\">");
    }

    void pole_txt(String n)
    {
        String v = mapa.get(n);
        out.println("<input type=\"text\" name=\""+esc(n)+"\" value=\""+esc(v)+"\" size=\""+length+"\">");
        hidden(n+"_", v);
    }

    void pole_radio(String n, String a)
    {
        String v = mapa.get(n, "0");
        String sel = v.equals(a) ? " checked" : "";
        out.println("<input type=\"radio\" name=\""+esc(n)+"\" value=\""+esc(a)+"\""+sel+">");
        if (a.equals("0"))
            hidden(n+"_", v);
    }

    void pole_check(String n, String def)
    {
        String v0 = mapa.get(n+"_", "");
        if (!v0.equals(""))
          def = "0";	// default liczy sie tylko za pierwszym razem, potem brak oznacza odznaczone
        String v = mapa.get(n, def);
        String sel = v.equals("1") ? " checked" : "";
        out.println("<input type=\"checkbox\" name=\""+esc(n)+"\" value=\"1\""+sel+">");
        hidden(n+"_", v);
    }
    
    void pole_select(String n, LinkedList l, boolean numeruj)
    {
        out.println("<select name=\""+esc(n)+"\">");
        String v = mapa.get(n, "0");
        int a = 0;
        while (l.size()>0)
        {
            String txt = (String)l.removeFirst();
            String cur = numeruj ? (""+a) : txt;
            String sel = v.equals(cur) ? " selected" : "";
            out.println("<option value=\""+esc(cur)+"\""+sel+">"+esc(txt)+"</option>");
            ++a;
        }
        out.println("</select>");
        hidden(n+"_", v);
    }

    void button(String val, String txt)
    {
        out.println("<button type=\"submit\" name=\"akcja\" value=\""+esc(val)+"\">"+esc(txt)+"</button>");
    }
  
    void pokaz_blad(String blad_wzoru)
    {
        if (!blad_wzoru.equals(""))
            out.println("<font color=\"red\"><b>"+blad_wzoru+"</b></font><br>");
    }
    
///////////////////////////

    void wzor(String txt, String n)
    {
        start_row(txt+":");
        pole_txt("p_"+n);
        stop_row();
    }

    /**
     * Wyswietla nasz dodatek do strony z lista aukcji.
     * @param img_alt Lista altow wszystkich obrazkow na stronie (do wyboru "kup teraz").
     * @param blad_wzoru Ewentualny blad, ktory zostanie wyswietlony.
     */
    public void stopka_dla_listy(LinkedList img_alt, String blad_wzoru)
    {
        LinkedList lista;
        out.println("<hr>");
        start_form();
        hidden("schemat", mapa.get("schemat"));
        hidden("url", mapa.get("url"));
        start_table(false);
        length = 50;

        start_row("Wpisz nazwy dwch aukcji:");
        pole_txt("nazwa_aukcji0");
        out.println("<br>");
        pole_txt("nazwa_aukcji1");
        stop_row();

        start_row("Ewentualnie inny przykad nazw dwch aukcji:");
        pole_txt("nazwa_aukcji2");
        out.println("<br>");
        pole_txt("nazwa_aukcji3");
        stop_row();

        start_row("Wpisz cen:");
        pole_txt("cena");
        stop_row();

        start_row("Kolejno cen:");
        lista = new LinkedList();
        lista.add("Najpierw zwyka, potem kup teraz");
        lista.add("Najpierw kup teraz, potem zwyka");
        lista.add("Nigdy nie ma ceny kup teraz");
        pole_select("kolejnosc", lista, true);
        stop_row();

        start_row("Znacznik kup teraz:");
        pole_radio("kup_teraz", "0");
        out.println("Tekst: ");
        pole_txt("kup_teraz_txt");
        out.println("<br>");
        pole_radio("kup_teraz", "1");
        out.println("Obrazek, alt= ");
        pole_select("kup_teraz_img", (LinkedList)img_alt.clone(), false);
        stop_row();

        start_row("Wpisz liczb ofert:");
        pole_txt("ile_ofert");
        stop_row();

        start_row("Opis:");
        pole_txt("lo_opis");
        stop_row();

        start_row("Obrazki:");
        pole_check("lo_czy_obrazki", "0");
        pole_select("lo_obrazki_alt", img_alt, false);
        stop_row();

        start_row("Wchod w aukcje:");
        pole_check("lo_wchodz", "1");
        stop_row();

        start_row("Nastpna strona:");
        pole_txt("nastepna");
        stop_row();
        
        start_row("Kategoria (dla caej strony):");
        pole_txt("lo_kategoria");
        stop_row();
        
        start_row("Kategoria (dla czci ofert):");
        pole_txt("lo_kategoria2");
        stop_row();
        
        stop_table(false);
        start_table(true);        
        length = 100;

        wzor("Wiersz", "wiersz");
        wzor("Nazwa", "nazwa");
        wzor("Cena", "cena");
        wzor("Ile ofert", "ile_ofert");
        wzor("Kup teraz", "kup_teraz");
        wzor("Opis", "lo_opis");
        wzor("Obrazki", "lo_obrazki");
        wzor("Nastepna", "nastepna");
        wzor("Kategoria (dla caej strony)", "lo_kategoria");
        wzor("Kategoria (dla czci ofert)", "lo_kategoria2");

        stop_table(true);
        out.println("<hr>");
        pokaz_blad(blad_wzoru);
        button("lista", "Prbuj parsowa");
        out.println("<br>");
        button("schemat", "Sparsowao ok, zapamietaj");
        stop_form();
    }

    /**
     * Wyswietla nasz dodatek do strony z lista kategorii.
     * @param blad_wzoru Ewentualny blad, ktory zostanie wyswietlony.
     */
    public void stopka_dla_lk(String blad_wzoru)
    {
        out.println("<hr>");
        start_form();
        hidden("schemat", mapa.get("schemat"));
        hidden("url", mapa.get("url"));
        start_table(false); 
        length = 50;

        start_row("Wpisz nazwy dwch kategorii:");
        pole_txt("nazwa_kat0");
        out.println("<br>");
        pole_txt("nazwa_kat1");
        stop_row();

        start_row("Ewentualnie wpisz nazwy dwch kategorii, ktre nie prowadz do listy aukcji:");
        pole_txt("nazwa_glkat0");
        out.println("<br>");
        pole_txt("nazwa_glkat1");
        stop_row();
        
        start_row("Dwupoziomowe kategorie:");
        pole_check("lk_dwupoziomowe", "0");
        stop_row();
        
        stop_table(false);
        start_table(true);        
        length = 100;

        wzor("Kategoria", "kat");
        wzor("Kategoria gwna", "glkat");

        stop_table(true);
        out.println("<hr>");
        pokaz_blad(blad_wzoru);
        button("kategorie", "Prbuj parsowa");
        out.println("<br>");
        button("schemat", "Sparsowao ok, zapamietaj");
        stop_form();
        out.println("<hr><h2>Pouczenie</h2>");
        out.println("Jeli jest strona, z ktrej mona wchodzi od razu do listy aukcji w kateroriach, wypenij tylko pierwsz cz. Program musi wykrywa tylko gwne kategorie.<br>");
        out.println("Jeli tak nie jest, to musisz stworzy schemat dla listy kategorii wsppracujcy ze stronami na obu poziomach.");
        out.println("Na stronie gwnej powinno si wykrywa kategorie drug czci, a na stronie, z ktrej ju si da wej na list aukcji pierwsz czci.");
    }

    void podwojne_pole(String txt, String n)
    {
        start_row(txt+":");
        pole_txt("wa_"+n);
        out.println("</td><td>");
        pole_txt("a_"+n);
        stop_row();
    }

    /**
     * Wyswietla nasz dodatek do strony z aukcja.
     * @param dodatkowe Lista niestandardowych pol (sparsowana zawartosc "Dodatkowe pola").
     * @param remarks Lista tresci wszystkich komentarzy na stronie (uzywana do wyboru konca aukcji).
     * @param blad_wzoru Ewentualny blad, ktory zostanie wyswietlony.
     */
    public void stopka_dla_aukcji(LinkedList dodatkowe, LinkedList remarks, String blad_wzoru)
    {
        LinkedList dodatkowe2 = (LinkedList)dodatkowe.clone();
        out.println("<hr>");
        start_form();
        hidden("schemat", mapa.get("schemat"));
        hidden("url", mapa.get("url"));
        start_table(false);
        length = 50;

        start_row("");
        out.println("Pierwsze sowo</td><td>Oststnie sowo");
        stop_row();

        start_row("Wpisz nazw kategorii:");
        pole_txt("a_nazwa_kat0");
        out.println("</td><td>");
        pole_txt("a_nazwa_kat1");
        stop_row();

        start_row("");
        out.println("Tekst wiodcy</td><td>Warto");
        stop_row();

        podwojne_pole("Cena", "cena");
        podwojne_pole("Cena kup teraz", "cena_kup_teraz");
        podwojne_pole("Sprzedawca", "sprzedawca");
        podwojne_pole("Czas koca", "czas_konca");

        start_row2("Format daty:");
        pole_txt("a_data_for");
        stop_row();
        
        start_row2("Jzyk (np. pl, en, ...):");
        pole_txt("a_jezyk");
        stop_row();
        

        start_row2("Dodatkowe pola");
        pole_txt("a_dodatkowe");
        stop_row();

        if (dodatkowe.size()>0)
        {
            start_row("");
            out.println("Tekst wiodcy</td><td>Warto");
            stop_row();
        }
        while (dodatkowe.size()>0)
        {
            String p = (String)dodatkowe.removeFirst();
            podwojne_pole(p, "x_"+p);
        }

        start_row2("Opis - start");
        pole_txt("a_opis");
        stop_row();
        start_row2("Ile napisow \"Opis\" jest przed opisem?");
        pole_txt("a_opis_nr");
        stop_row();
        start_row2("Znacznik koca opisu:");
        pole_radio("a_koniec", "0");
        out.println("Tekst: ");
        pole_txt("a_koniec_txt");
        out.println("<br>");
        pole_radio("a_koniec", "1");
        out.println("Znacznik w komentarzu: ");
        pole_select("a_koniec_remark", remarks, false);
        stop_row();

        start_row2("Atrybuty - dwie nazwy:");
        pole_txt("a_atr0");
        out.println("<br>");
        pole_txt("a_atr1");
        stop_row();
        start_row2("Atrybuty - warto:");
        pole_txt("a_atrv");
        stop_row();
        start_row2("Atrybuty (inny rodzaj) - dwie nazwy:");
        pole_txt("a_atr02");
        out.println("<br>");
        pole_txt("a_atr12");
        stop_row();
        start_row2("Atrybuty (inny rodzaj) - warto:");
        pole_txt("a_atrv2");
        stop_row();
        
        stop_table(false);
        start_table(true);        
        length = 100;
        wzor("Kategoria - cao", "a_nazwa_kat_cale");
        wzor("Kategoria - element", "a_nazwa_kat");
        wzor("Cena", "a_cena");
        wzor("Cena kup teraz", "a_cena_kup_teraz");
        wzor("Sprzedawca", "a_sprzedawca");
        wzor("Czas koca", "a_czas_konca");
        while (dodatkowe2.size()>0)
        {
            String p = (String)dodatkowe2.removeFirst();
            wzor(p, "a_x_"+p);
        }
        wzor("Opis", "a_opis");
        wzor("Atrybuty - wiersz", "a_atrybut");
        wzor("Atrybuty - nazwa", "a_atr_nazwa");
        wzor("Atrybuty - warto", "a_atr_war");
        wzor("Atrybuty (inny rodzaj) - wiersz", "a_atrybut2");
        wzor("Atrybuty (inny rodzaj) - nazwa", "a_atr_nazwa2");
        wzor("Atrybuty (inny rodzaj) - warto", "a_atr_war2");

        stop_table(true);
        out.println("<hr>");
        pokaz_blad(blad_wzoru);
        button("aukcja", "Prbuj parsowa");
        out.println("<br>");
        button("schemat", "Sparsowao ok, zapamietaj");
        stop_form();
        out.println("<hr><h2>Pouczenie</h2>");
        out.println("<b>Dodatkowe pola</b> to na przykad: lokalizacja, transport, platnosc, liczba_przedmiotow, ile_ofert). "+
          "Wartoci naley wpisywa pooddzielane spacjami, podane nazwy bd nazwami w bazie danych. <br>"+
          "<b>Format daty</b> opisywany jak w SimpleDateFormat, oraz dodatkowo ? na sowo do wyrzucenia (dziaa przed i po wyraeniu). "+
          "Na przyklad: ? dd MMM yyyy HH:mm:ss ?");
    }


    /**
     * Wyswietla glowna strone konfiguratora.
     * @param lista Lista istniejacych schematow parsowania.
     */
    public void main_page(LinkedList lista)
    {
        start_html("Konfigurowalny parser");
        out.println("Konfigurowalny parser");

        start_form();
        start_table(false);
        out.println("<tr><td>"); 
        pole_select("schemat", lista, false);
        out.println("</td><td>");
        button("schemat", "Edytuj schemat");
        out.println("</td></tr>");
        stop_table(false);
        stop_form();

        start_form();
        start_table(false);
        out.println("<tr><td>"); 
        pole_txt("schemat");
        out.println("</td><td>");
        button("schemat", "Twrz schemat");
        out.println("</td></tr>");
        stop_table(false);
        stop_form();

        stop_html();
    }

    /**
     * Wyswietla glowna strone edycji schematu.
     */
    public void edycja_schematu()
    {
        start_html("Konfigurowalny parser - edycja schematu");
        out.println("<h1>Edycja schematu - "+esc(mapa.get("schemat"))+"</h1>");
        start_form();
        hidden("schemat", mapa.get("schemat"));

        start_table(false);

        start_row("Strona z kategoriami:");
        pole_txt("main_url");
        stop_row();

        start_row("Strona z komentarzami (do znaku =):");
        pole_txt("kom_url");
        stop_row();

        start_row("Kupjcy:");
        pole_txt("kom_kupujacy");
        stop_row();

        start_row("Sprzedajcy:");
        pole_txt("kom_sprzedajacy");
        stop_row();

        stop_table(false);
        button("schemat", "Zapisz");

        out.println("<hr>Edycja schematw:");
        start_table(false);
        start_row("Przykad strony:");
        pole_txt("url");
        stop_row();
        stop_table(false);
        button("kategorie", "Lista kategorii");
        button("lista", "Lista aukcji");
        button("aukcja", "Aukcja");
//        out.println("<br>");
//        button("sciagaj", "Sciagaj");
        
        out.println("<hr><h2>Pouczenie</h2>");
        out.println("W pole \"przykad strony\" wpisz adres strony odpowiadajcej temu przyciskowi, w ktry klikasz na dole (np. adres strony z list aukcji jeli klikasz \"Lista aukcji\").<br>");
        out.println("Jeli struktura kategorii jest wielopoziowa (nie da si wej z jednej strony we wsystkie kategorie), to musisz stworzy schemat dla listy kategorii wsppracujcy ze stronami na obu poziomach.");

        stop_form();
        stop_html();
    }

    ///!!!
    void show(Cos ja)
    {
        if (Tools.isText(ja.node))
            System.out.println("Text: \""+((Text)ja.node).getText()+"\"");
        else
        if (Tools.isTagPossiblyEmpty(ja.node))
            System.out.println("Tag: "+((Tag)ja.node).getTagName()+"*, "+ja.first);
        else
            System.out.println("Cos dziwnego");
    }

    /**
     * Wyswietla strone podana jako argument.
     * @param main_cos Glowny wezel strony do wyswietlenia.
     */
    public void wyswietl_strone(Cos main_cos)
    {
        
        System.out.println(main_cos.toString());
        for (Cos c = main_cos.next; c.nr<=main_cos.pair.prev.nr; c = c.pair.next)
            out.print(c.node.toHtml());
    }

    void wstaw_napis(String before, String after, Cos el) throws ParserException
    {
        Node n = el.node;
        if (n==null || n.getParent()==null) return;
        NodeIterator it = n.getParent().getChildren().elements();
        NodeList l2 = new NodeList();
        while (it.hasMoreNodes())
        {
            Node n2 = it.nextNode();
            if (n2==n && !before.equals(""))
                l2.add(new TextNode(before));
            l2.add(n2);
            if (n2==n && !after.equals(""))
                l2.add(new TextNode(after));
        }
        n.getParent().setChildren(l2);
    }

    /**
     * Obejmij caly obszar wskazywany przez argument w nawiasy kwadratowe i poprzec tekstem.
     * @param txt Tekst, ktorym zostanie poprzedzony fragment.
     * @param start Poczatek fragmentu.
     * @param stop Koniec fragmentu.
     */
    public void zamieniaj(String txt, Cos start, Cos stop) throws ParserException
    {
        if (start.nr>stop.nr)
          return;
        wstaw_napis("["+txt, "", start);
        wstaw_napis("", "]", stop);
    }

    /**
     * Znajdz tekst podany jako argument we wskazanym obszarze htmla (musi
     * wystepowac w spojnym kawalku), otocz go nawiasami i poprzedz tekstem.
     * @param wstaw Tekst, ktorym zostanie poprzedzony znaleziony tekst.  
     * @param stare Tekst, ktorego szukamy.
     * @param start Poczatek fragmentu. 
     * @param stop Koniec fragmentu.
     */
    public void zamieniaj_str(String wstaw, String stare, Cos start, Cos stop) throws ParserException
    {
        if (stare==null || stare.equals(""))
            return;
        for (Cos c = start; c.nr<=stop.nr; c = c.next)
            if (Tools.isText(c.node))
            { 
                String s = c.node.getText();
                int i1 = s.indexOf(stare);
                if (i1<0) continue;
                int i2 = i1+stare.length();
                c.node.setText(s.substring(0, i1)+"["+wstaw+s.substring(i1, i2)+"]"+
                    s.substring(i2, s.length()));
                return;
            }
    }

};

