
package com.aukcjomat.parser;

import java.util.*;

/**
 * Mapa do przechowywania par String -> String.
 *
 * @author Pawel Parys
 */
public class Mapa
{
    /**
     * Prawdziwa mapa, w ktorej sa trzymane dane.
     */
    public HashMap mapa;
    public String nazwa;
    
    /**
     * Pobierz wartosc.
     * @param n Nazwa.
     * @param def Wartosc domyslna.
     * @return Wartosc odpowiadajaca podanej nazwie lub, jesli jej nie ma w mapie, wartosc domyslna.
     */
    public String get(String n, String def)
    {
        Object obj = mapa.get(n);
        return obj==null ? def : (String)obj;
    }

    /**
     * Pobierz wartosc.
     * @param n Nazwa.
     * @return Wartosc odpowiadajaca podanej nazwie lub, jesli jej nie ma w mapie, pusty String.
     */
    public String get(String n)
    {
        return get(n, "");
    }


    /**
     * Wstawia inna mape do tej. Wartosci wstawianej mapy powinny byc tablicami Stringow. 
     * Z takiej tablicy wybierane jest tylko pierwsze pole.
     * Jesli jakis klucz juz wystepuje, para jest nadpisywana.
     * @param mapa_zr Zwykla mapa, ktora jest dodawana. Musi to byc mapa String -> String[].
     */
    public void dorzuc_mape(Map mapa_zr)
    {
        Iterator it = mapa_zr.entrySet().iterator();
        while (it.hasNext())
        {
            Map.Entry e = (Map.Entry)it.next();
            mapa.put(e.getKey(), ((String[])e.getValue())[0]);
        }
    }

    /**
     * Uaktualnia mape, pod warunkiem, ze v jest niepuste.
     * @param n Klucz.
     * @param v Wartosc.
     */
    public void update(String n, String v)
    {
        if (!v.equals(""))
            mapa.put(n, v);
    }

    /**
     * Tworzy Mape na podstawie zwyklej mapy String -> String.
     * @param map Mapa typu String -> String. Moze byc null.
     */
    public Mapa(String naz, HashMap map)
    {
      nazwa = naz;
      mapa = (map==null) ? new HashMap() : map;
    }
};
