
package com.aukcjomat.parser;

import org.htmlparser.*;
import org.htmlparser.util.*;
import java.util.*;

public class Okreslacz
{
    public Cos main_cos;
    

    String esc2(String s)
    {
        String s2 = "";
        for (int a = 0; a<s.length(); a++)
            if (s.charAt(a)=='"')
                s2 += "\\\"";
            else
            if (s.charAt(a)=='\'')
                s2 += "\\'";
            else
            if (s.charAt(a)=='\\')
                s2 += "\\\\";
            else
                s2 += s.charAt(a);
        return s2;
    }

    Set sciezka_przodkow(Cos c)
    {
        Set s = new HashSet();
        while (c!=null)
        {
            s.add(c);
            c = c.up;
        }
        return s;
    }
    
    Cos znajdz_wspolnego_przodka(Cos n0, Cos n1)
    {
        Set s0 = sciezka_przodkow(n0);
        while (!s0.contains(n1))
            n1 = n1.up;
        return n1;
    }
    
    Cos poziom_wglab(Cos ja, Cos cel)
    {
        while (cel.up!=ja)
            cel = cel.up;
        return cel;
    }
    
    
    String sch_start(Cos cos)
    {
        if (Tools.isText(cos.node))
            return "\""+esc2(cos.node.getText())+"\"";
        if (Tools.isTagPossiblyEmpty(cos.node))
        {
            Tag t = (Tag)cos.node;
            String s = Tools.daj_klase(t);
            return "<"+t.getTagName()+((sch_gen_classes && s!=null) ? " \""+esc2(s)+"\"" : "")+">";
        }
        return "";
    }
    
    String sch_stop(Cos cos)
    {
        if (Tools.isTagPossiblyEmpty(cos.node))
        {
            Tag t = (Tag)cos.node;
            return "</"+t.getTagName()+">";
        }
        return "";
    }
    
    boolean sch_gen_classes;
    
    String ogolny_schemat(Cos low, Cos high, String wnetrze)
    {
        while (high!=low && high!=null)
        {
            wnetrze = sch_start(high)+wnetrze+sch_stop(high);
            high = high.up;
            if (high!=low)
                wnetrze = "?"+wnetrze+"?";
        }
        return wnetrze;
    }

    String dokladny_schemat(Cos low, Cos high, String wnetrze, Set badane)
    {
        String ret = "";
        Set sciezka = sciezka_przodkow(high);
        //gen_html.out.println(""+sciezka.contains(low));
        for (Cos c = low.next; c.nr<=low.pair.prev.nr; c = c.next)
        {
            if (Tools.isTagPossiblyEmpty(c.node) && 
                (badane==null || badane.contains(((Tag)c.node).getTagName())))
            {
                if (c.first)
                    ret += sch_start(c);
                else
                    ret += sch_stop(c);
                continue;
            }
/*            if (sciezka.contains(c))
                ret += wnetrze;
            else
            if (Tools.isTagPossiblyEmpty(c.node) && (ret.equals("") || ret.charAt(ret.length()-1)!='?'))
                ret += "?";*/
            if (ret.equals("") || ret.charAt(ret.length()-1)!='?')
                ret += "?";
            if (sciezka.contains(c))
                ret += wnetrze+"?";
            c = c.pair;
        }
        return ret;
    }



    Set tagi_tablicowe()
    {
        Set tagi_tablicowe = new HashSet();
        tagi_tablicowe.add("TABLE");
        tagi_tablicowe.add("TBODY");
        tagi_tablicowe.add("TR");
        tagi_tablicowe.add("TD");
        return tagi_tablicowe;
    }
////////////////////////////////////////////

    public String lk_kategoria(String w0, String w1)
    {
        Cos n0 = main_cos.znajdz_str(w0);
        Cos n1 = main_cos.znajdz_str(w1);
        if (n0==null || n1==null)
            return "";
        Set tagi_tabl = tagi_tablicowe();
        Cos table = znajdz_wspolnego_przodka(n0, n1);
        for (;;)
        {
          Node n = table.up.node;
          if (n==null || !Tools.isTag(n) || !tagi_tabl.contains(((Tag)n).getTagName()))
            break;
          table = table.up;
        }
        if (table==n0 || table==n1) 
            return "";
        Cos a = n0;
        while (a.node!=null && (!Tools.isTag(a.node) || !Tools.tagIs((Tag)a.node, "A")))
          a = a.up;
        sch_gen_classes = true;
        String sch0 = ogolny_schemat(a.up, n0.up, "?");
        sch0 = ogolny_schemat(table.up, a.up, "?("+sch0+")?");
        return sch0;
    }

////////////////////////////////////////

    public String lista_wiersz(String w0, String w1)
    {
        Cos n0 = main_cos.znajdz_str(w0);
        Cos n1 = main_cos.znajdz_str(w1);
        if (n0==null || n1==null)
            return "";
        Cos table = znajdz_wspolnego_przodka(n0, n1);
        if (table==n0 || table==n1) 
            return "";
        Cos tr = poziom_wglab(table, n0);
        sch_gen_classes = false;
        String sch0 = dokladny_schemat(tr, n0, "?", tagi_tablicowe());
        sch0 = ogolny_schemat(table.up, tr, "("+sch0+")");
        return sch0;
    }

    public String lista_nastepna(String test)
    {
        Cos cur = main_cos.znajdz_str(test);
        if (cur==null)
            return "";
        Cos x = cur;
        while (x.node!=null && (!Tools.isTag(x.node) || !Tools.tagIs((Tag)x.node, "A")))
            x = x.up;
        sch_gen_classes = true;
        return "("+ogolny_schemat(x.up, cur, "")+")";
    }

    public String lista_kategoria(String test)
    {
        Cos cur = main_cos.znajdz_str(test);
        if (cur==null)
            return "";
        sch_gen_classes = true;
        return ogolny_schemat(cur.up.up.up, cur.up, "(?)");
    }
    
    String pole(String text, Cos start, Cos stop, boolean cale)
    {
        Cos cur = Cos.znajdz_str(text, start, stop);
        if (cur==null)
            return "";
        Cos x = cur;
        while (x.node!=null && (!Tools.isTag(x.node) || !Tools.tagIs((Tag)x.node, "TD")))
            x = x.up;
        sch_gen_classes = false;
        String sch = ogolny_schemat(x, cur.up, cale ? "?" : "(?)");
        sch = dokladny_schemat(start.up, cur, cale ? ("("+sch+")") : sch, tagi_tablicowe());
        System.out.println("aaa2:"+text+":"+sch+":");
        return sch;
    }
    
    public String lista_nazwa(String text, Cos start, Cos stop)
    {
        return pole(text, start, stop, true);
    }
    
    public String lista_kup_teraz(String typ, String text, String img, Cos start, Cos stop)
    {
        Cos cur = typ.equals("0") ? Cos.znajdz_str(text, start, stop) : 
            Cos.znajdz_img(img, start, stop);
        if (cur==null)
            return "";
        Cos x = cur;
        while (x.node!=null && (!Tools.isTag(x.node) || !Tools.tagIs((Tag)x.node, "TD")))
            x = x.up;
        sch_gen_classes = true;
        String sch = typ.equals("0") ? ogolny_schemat(x, cur.up, "(\""+esc2(cur.node.getText())+"\")") :
            ogolny_schemat(x, cur, "()");
        sch_gen_classes = false;
        sch = dokladny_schemat(start.up, cur, sch, tagi_tablicowe());
        return sch;
    }
    
    public String lista_cena(String text, Cos start, Cos stop)
    {
        return pole(text, start, stop, false);
    }
    
    public String lista_ile_ofert(String text, Cos start, Cos stop)
    {
        return pole(text, start, stop, false);
    }

    public String lista_opis(String text, Cos start, Cos stop)
    {
        return pole(text, start, stop, false);
    }
    
    public String lista_obrazki(String img, Cos start, Cos stop)
    {
        Cos cur = Cos.znajdz_img(img, start, stop);
        if (cur==null)
            return "";
        Cos x = cur;
        while (x.node!=null && (!Tools.isTag(x.node) || !Tools.tagIs((Tag)x.node, "TD")))
            x = x.up;
        sch_gen_classes = false;
        String sch = ogolny_schemat(x, cur.up, "?");
        sch = dokladny_schemat(start.up, cur, "("+sch+")", tagi_tablicowe());
        return sch;
    }

//////////////////////////////////////////////

    public String a_zwykle(String text, String prow, boolean z_linkiem)
    {
        Cos n1 = main_cos.znajdz_str(prow);
        Cos n0 = Cos.znajdz_str(text, n1, main_cos.pair);
        if (n0==null || n1==null)
            return "";
        Cos wsp = znajdz_wspolnego_przodka(n0, n1);
        sch_gen_classes = true;
        if (z_linkiem)
            while (n0!=wsp && n0.node!=null && (!Tools.isTag(n0.node) || !Tools.tagIs((Tag)n0.node, "A")))
                n0 = n0.up;
        String sch_pr = ogolny_schemat(wsp, n1, "");
        String sch = ogolny_schemat(wsp, n0.up, "(?)");
        sch = ogolny_schemat(wsp.up, wsp, "?"+sch_pr+sch+"?");
        return sch;
    }
    
    public String a_kategoria(String pocz, String kon)
    {
        Cos n1 = main_cos.znajdz_str(kon);
        Cos n0 = main_cos;
        if (n0==null || n1==null)
            return "";
        for (;;)
        {
            Cos n0n = Cos.znajdz_str(pocz, n0.next, n1);
            if (n0n==null) break;
            n0 = n0n;
        }
        Cos wsp = znajdz_wspolnego_przodka(n0, n1);
        sch_gen_classes = true;
        String sch = ogolny_schemat(wsp, n0.up, "?");
        String sch1 = ogolny_schemat(wsp.up, wsp, "(?"+sch+"?)");
        return sch1;
    }
    
    public String a_kategoria_wew(String pocz, String kon, Cos start, Cos stop)
    {
        Cos n0 = main_cos.znajdz_str(kon, start, stop);
        if (n0==null)
            return "";
        sch_gen_classes = true;
        String sch = ogolny_schemat(start.up, n0.up, "(?)");
        return sch;
    }

    public String a_opis(String ktory, String pocz, String typ, String kon_txt, String kon_rem)
    {
        int kt = 0;
        try
        {
            kt = Integer.parseInt(ktory)-1;
        }
        catch (NumberFormatException e) { }
        Cos start = main_cos.znajdz_str(pocz);
        while (kt>0 && start!=null)
        {
            start = Cos.znajdz_str(pocz, start.next, main_cos.pair);
            --kt;
        }
        Cos stop = typ.equals("0") ? main_cos.znajdz_str(kon_txt) : 
            main_cos.znajdz_remark(kon_rem);
        if (start==null || stop==null)
            return "";
        Cos wsp = znajdz_wspolnego_przodka(start, stop);

        sch_gen_classes = true;
        String sch_pr = ogolny_schemat(wsp, start, "");
        String sch = typ.equals("0") ? ogolny_schemat(wsp, stop, "") :
            ogolny_schemat(wsp, stop, "'"+esc2(kon_rem)+"'");
        //sch = ogolny_schemat(wsp.up, wsp, "?"+sch_pr+"(?)"+sch+"?");
        return sch_pr+"(*)"+sch;
    }

    public String atrybut(String w0, String w1)
    {
        Cos n0 = main_cos.znajdz_str(w0);
        Cos n1 = main_cos.znajdz_str(w1);
        if (n0==null || n1==null)
            return "";
        Cos table = znajdz_wspolnego_przodka(n0, n1);
        if (table==n0 || table==n1) 
            return "";
        Cos tr = poziom_wglab(table, n0);
        sch_gen_classes = true;
        String sch0 = dokladny_schemat(tr, n0, "?", tagi_tablicowe());
        sch0 = ogolny_schemat(table.up, tr, "("+sch0+")");
        return sch0;
    }
    
    public String atr_nazwa(String text, Cos start, Cos stop)
    {
        return pole(text, start, stop, false);
    }
    
    public String atr_wartosc(String text, Cos start, Cos stop)
    {
        return pole(text, start, stop, false);
    }



///////////////////////////////////////////////////////////////

    static public LinkedList znajdz_img_alt(Cos start, Cos stop) throws ParserException
    {
        LinkedList lista = new LinkedList();
        for (Cos c = start; c.nr<=stop.nr; c = c.next)
            if (c.first && Tools.isTagPossiblyEmpty(c.node) && Tools.tagIs((Tag)c.node, "IMG"))
            {
                String alt = ((Tag)c.node).getAttribute("alt");
                if (alt!=null && alt!="")
                    lista.add(alt);
            }
        return lista;
    }

    public LinkedList znajdz_img_alt() throws ParserException
    {
        return znajdz_img_alt(main_cos, main_cos.pair);
    }

    public LinkedList znajdz_remarks() throws ParserException
    {
        LinkedList lista = new LinkedList();
        for (Cos c = main_cos; c.nr<=main_cos.pair.nr; c = c.next)
            if (c.first && Tools.isRemark(c.node))
                lista.add(c.node.getText());
        return lista;
    }

};