package com.aukcjomat.parser;


import org.htmlparser.*;
import org.htmlparser.util.*;
import java.util.*;
import java.text.*;

public class Rozpoznawacz
{

    public String blad_wzoru;

    Wzor wzor_cl = new Wzor();

    LinkedList lista;
    
    Object[] wzor;

    static int znajdz_kreske(String s, int x)
    {
        boolean in = false;
        boolean esc = false;
        for (; x<s.length(); ++x)
        {
            char ch = s.charAt(x);
            if (!in && ch=='|')
                return x;
            if (!esc && ch=='"')
                in = !in;
            else
            if (!esc && ch=='\\')
                esc = true;
            else
                esc = false;
        }
        return x;
    }

    
    void rozpoznaj(Cos cur, Cos stop, int iter, 
            Cos match_start, Cos match_stop, boolean po_pytajniku)
    {
        for (;;)
        {
            if (iter>=wzor.length)
            {
                if (lista.size()>0)
                {
                    Para p = (Para)lista.getLast();
                    int a = p.x.nr;
                    int b = p.y.nr;
                    int c = match_start.nr;
                    int d = match_stop.nr;
                    if (p.x.nr<=match_stop.nr && p.y.nr>=match_start.nr)
                        break;
                }
                if (match_start!=null && match_stop!=null)
                    lista.add(new Para(match_start, match_stop));
                break;
            }
            if (cur.nr>stop.nr)
                break;
            Wzor.Element el = (Wzor.Element)wzor[iter];
            
            if (el.rodzaj==Wzor.C_PYTAJNIK || el.rodzaj==Wzor.C_GWIAZDKA)
                rozpoznaj(cur, stop, iter+1, match_start, match_stop, true);
            else
            if (el.rodzaj==Wzor.C_NAWIAS_OTW)
                rozpoznaj(cur, stop, iter+1, cur, match_stop, po_pytajniku);
            else
            if (Tools.isText(cur.node) && el.rodzaj==Wzor.C_TEKST && cur.first && 
                    cur.node.getText().indexOf(el.nazwa)>=0)
                rozpoznaj(cur.pair.next, stop, iter+1, match_start, match_stop, false);
            else
            if (Tools.isRemark(cur.node) && el.rodzaj==Wzor.C_REMARK && cur.first && 
                    cur.node.getText().indexOf(el.nazwa)>=0)
                rozpoznaj(cur.pair.next, stop, iter+1, match_start, match_stop, false);
            else
            if (!Tools.isTagPossiblyEmpty(cur.node) && cur.first && !po_pytajniku)
                rozpoznaj(cur.pair.next, stop, iter, match_start, match_stop, false);
                // (tekst i remarki pomijamy)
            else
            if (el.rodzaj==Wzor.C_NAWIAS_ZAM)
                rozpoznaj(cur, stop, iter+1, match_start, cur.prev, po_pytajniku);
            else
            if (Tools.isTagPossiblyEmpty(cur.node) && Tools.tagIs((Tag)cur.node, el.nazwa) &&
                !(el.rodzaj==Wzor.C_TAG_ZAM && cur.first) &&
                !(el.rodzaj==Wzor.C_TAG_OTW && !cur.first) &&
                !(el.rodzaj==Wzor.C_TAG_OTW_Z_KLASA && 
                    (!cur.first || !Tools.klasa((Tag)cur.node, el.klasa))))
                rozpoznaj(cur.next, stop, iter+1, match_start, match_stop, false);

            if (el.rodzaj==Wzor.C_PYTAJNIK && cur.first && !po_pytajniku)
            {
                cur = cur.pair.next;
                continue;
            }
            if (el.rodzaj==Wzor.C_GWIAZDKA && !po_pytajniku)
            {
                cur = cur.next;
                continue;
            }
            break;
        }
    }
    
    public LinkedList dzialaj(String wz_str, Cos start, Cos stop, String jaki_blad)
    {
        try
        {
            lista = new LinkedList();
            int x = 0;
            while (x<wz_str.length())
            {
                int y = znajdz_kreske(wz_str, x);
                wzor = wzor_cl.napis2wzor(wz_str.substring(x, y));
                for (Cos c = start; c.nr<=stop.nr; c = c.next)
                    rozpoznaj(c, stop, 0, null, null, true);
                x = y+1;
            }
            return lista;
        }
        catch (Wzor.BladWzoru e)
        {
            blad_wzoru = "Bledna postac wzoru na "+jaki_blad+": "+e.x;
            return new LinkedList();
        }
    }
    
    public String rozpoznaj_linka(Cos start, Cos stop) throws ParserException
    {
        for (Cos c = start; c.nr<=stop.nr; c = c.next)
        {
            if (!c.first || !Tools.isTag(c.node))
                continue;
            Tag tag = (Tag)c.node;
            if (Tools.tagIs(tag, "A"))
            {
                String ret = tag.getAttribute("href");
                if (ret!=null)
                    return ret;
            }
        }
        return "";
    }
    
    public String rozpoznaj_tresc(Cos start, Cos stop, String za_tagi) throws ParserException
    {
        String ret_str = "";
        for (Cos c = start; c.nr<=stop.nr; c = c.next)
        {
            if (!c.first)
                continue;
            if (c.czy_pominac())
            {
                c = c.pair;
                continue;
            }
            if (Tools.isText(c.node))
                ret_str += c.node.getText();
            else
                ret_str = ret_str.trim()+za_tagi;
        }
        return ret_str.trim();
    }
    
    public String rozpoznaj_tresc(Cos start, Cos stop) throws ParserException
    {
        return rozpoznaj_tresc(start, stop, " ");
    }


    int do_cyfry(String napis, int x0)
    { 
        int x;
        for (x = x0; x<napis.length(); ++x)
            if (Character.isDigit(napis.charAt(x)))
                break;
        return x;
    }

    int do_konca(String napis, int x0)            // znajdz koniec ceny
    {
        int x;
        for (x = x0; x<napis.length(); ++x)
            if (!Character.isDigit(napis.charAt(x)) && napis.charAt(x)!=',' 
                && napis.charAt(x)!='.' && napis.charAt(x)!=' ')
                break;
        return x;
    }

    String popraw_cene(String s)
    {
        if (s==null || s.equals(""))
          return "";
        String ret = "";
        int kr = Math.max(s.lastIndexOf("."), s.lastIndexOf(","));
        for (int a = 0; a<s.length(); ++a)
        {
            char ch = s.charAt(a);
            if (ch==' ' || ((ch==',' || ch=='.') && a!=kr)) continue;
            if (ch==',') ch = '.';
            ret += ch;
        }
        if (kr>=0 && kr==s.length()-1)
            ret += "00";
        return ret;
    }


    public String cena_zw, cena_kt;
    public boolean naprawiaj_cene;

    public void rozpoznaj_ceny_na_liscie(Cos start, Cos stop, boolean kup_teraz, 
        boolean najpierw_kup_teraz) throws ParserException
    {
        String str = rozpoznaj_tresc(start, stop, "x");
        int s1 = do_cyfry(str, 0);
        int k1 = do_konca(str, s1);
        int s2 = do_cyfry(str, k1);
        int k2 = do_konca(str, s2);
        String c1 = str.substring(s1, k1).trim();
        String c2 = str.substring(s2, k2).trim();
        String c_zw = "", c_kt = "";
        cena_zw = cena_kt = "";
        if (c2.length()==0)
            if (kup_teraz)
                cena_kt = c1;
            else
                cena_zw = c1;
        else
            if (najpierw_kup_teraz)
                { cena_kt = c1; cena_zw = c2; }
            else
                { cena_zw = c1; cena_kt = c2; }
        if (naprawiaj_cene)
        {
            cena_zw = popraw_cene(cena_zw);
            cena_kt = popraw_cene(cena_kt);
        }
    }

    public String rozpoznaj_cene(Cos start, Cos stop) throws ParserException
    {
        String str = rozpoznaj_tresc(start, stop);
        int s1 = do_cyfry(str, 0);
        int k1 = do_konca(str, s1);
        str = str.substring(s1, k1);
        if (naprawiaj_cene)
            str = popraw_cene(str);
        return str;
    }

    long parsuj_czas(String s, String fmt, String lang)
    {
        try
        {
            System.out.println(">"+s+"<>"+fmt+"<>"+lang+"<");
            s = s.trim();
            Locale l = new Locale(lang);
            DateFormat df = new SimpleDateFormat(fmt, l);
            return df.parse(s).getTime();
        }
        catch (ParseException e)
        {
            System.out.println("Blad: " + e.toString());
            e.printStackTrace();
            return -1;
        }
    }


    public long rozpoznaj_date(Cos start, Cos stop, String fmt, String lang) throws ParserException
    {
        int ile_przed = 0, ile_po = 0;
        for (int a = 0; a<fmt.length() && (fmt.charAt(a)=='?' || fmt.charAt(a)==' '); ++a)
            if (fmt.charAt(a)=='?')
                ile_przed++;
        for (int a = fmt.length()-1; a>=0 && (fmt.charAt(a)=='?' || fmt.charAt(a)==' '); --a)
            if (fmt.charAt(a)=='?')
                ile_po++;
        fmt = fmt.replace('?', ' ').trim();
        String str = rozpoznaj_tresc(start, stop).trim();
        str = str.replace('\t', ' ');
        str = str.replace('\u00a0', ' ');
        //System.out.println(">"+str+"< "+ile_przed+" "+ile_po);
        while (ile_przed>0)
        {
            int x = str.indexOf(' ');
            if (x<0) break;
            str = str.substring(x+1, str.length()).trim();
            --ile_przed;
            //System.out.println(">"+str+"< "+ile_przed+" "+ile_po);
        }
        while (ile_po>0)
        {
            int x = str.lastIndexOf(' ');
            if (x<0) break;
            str = str.substring(0, x).trim();
            --ile_po;
            //System.out.println(">"+str+"< "+ile_przed+" "+ile_po);
        }
        return parsuj_czas(str, fmt, lang);
    }
    
};
