
package com.aukcjomat.parser;

import java.util.*;

public class Wzor
{
    public static final int C_NAWIAS_OTW = 0;
    public static final int C_NAWIAS_ZAM = 1;
    public static final int C_TAG_OTW = 2;
    public static final int C_TAG_OTW_Z_KLASA = 3;
    public static final int C_TAG_ZAM = 4;
    public static final int C_PYTAJNIK = 5;
    public static final int C_TEKST = 6;
    public static final int C_REMARK = 7;
    public static final int C_GWIAZDKA = 8;

    public class BladWzoru extends Exception
    { 
        public String x; 
        BladWzoru(String y) { x = y; } 
    };
    
    LinkedList lista;
    
    public class Element
    {
        
        public int rodzaj;
        public String nazwa;
        public String klasa;
        
        Element(int rodzaj)
        {
            this.rodzaj = rodzaj;
            lista.add(this);
        }
        Element(int rodzaj, String nazwa)
        {
            this.rodzaj = rodzaj;
            this.nazwa = nazwa;
            lista.add(this);
        }
        Element(int rodzaj, String nazwa, String klasa)
        {
            this.rodzaj = rodzaj;
            this.nazwa = nazwa;
            this.klasa = klasa;
            lista.add(this);
        }
    };
    
    int pos;
    String wz;
    
    void blad(String x) throws BladWzoru
    {
        throw new BladWzoru(x);
    }
    
    void next() throws BladWzoru
    {
        ++pos;
        if (pos>=wz.length()) blad("koniec napisu w srodku taga lub cudzyslowia");
    }

    void skip_spaces() throws BladWzoru
    {
        while (wz.charAt(pos)==' ') next();
    }
    
    String read_name(char quot) throws BladWzoru
    {
        String s = "";
        if (wz.charAt(pos)!=quot) blad("oczekiwano cudzyslowia");
        next();
        while (wz.charAt(pos)!=quot)
        {
            if (wz.charAt(pos)=='\\')
                next();
            s += wz.charAt(pos);
            next();
        }
        ++pos;
        return s;
    }

    public Object[] napis2wzor(String wzor_str) throws BladWzoru
    {
        lista = new LinkedList();
        wz = wzor_str;
        boolean byl_otw = false, byl_zam = false;
        for (pos = 0; pos<wz.length(); ++pos)
        {
            char ch = wz.charAt(pos);
            if (ch==' ') ;
            else
            if (ch=='?')
            {
                if (pos+2<wz.length() && wz.charAt(pos+1)=='(' && 
                      (wz.charAt(pos+2)=='?' || wz.charAt(pos+2)=='*'))
                    continue;
                new Element(C_PYTAJNIK);
            }
            else
            if (ch=='*')
            {
                if (pos+2<wz.length() && wz.charAt(pos+1)=='(' && 
                      (wz.charAt(pos+2)=='?' || wz.charAt(pos+2)=='*'))
                    continue;
                new Element(C_GWIAZDKA);
            }
            else
            if (ch=='(')
            {
                new Element(C_NAWIAS_OTW);
                if (byl_otw) blad("dwa otwarte nawiasy");
                byl_otw = true;
            }
            else
            if (ch==')')
            {
                new Element(C_NAWIAS_ZAM);
                if (byl_zam || !byl_otw) blad("zamykasz nie otwarty nawias");
                byl_zam = true;
            }
            else
            if (ch=='<')
            {
                next();
                boolean close = false;
                if (wz.charAt(pos)=='/') 
                {
                    close = true;
                    next();
                }
                String name = "";
                while (wz.charAt(pos)!=' ' && wz.charAt(pos)!='>')
                {
                    name += wz.charAt(pos);
                    next();
                }
                if (!close && wz.charAt(pos)!='>')
                {
                    skip_spaces();
                    String klasa = read_name('"');
                    --pos; next(); // check if not end
                    new Element(C_TAG_OTW_Z_KLASA, name, klasa);
                }
                else
                if (!close)
                    new Element(C_TAG_OTW, name);
                else
                    new Element(C_TAG_ZAM, name);
                if (wz.charAt(pos)!='>') blad("brakuje znaku &lt;");
            }
            else
            {
                if (wz.charAt(pos)=='\'')
                  new Element(C_REMARK, read_name('\''));
                else
                  new Element(C_TEKST, read_name('"'));
                --pos;
            }
        }
        if (!byl_zam) blad("brakuje nawiasu");
        return lista.toArray();
    }
};
